<form {% if application %}action="/edit/{{application.identifier}}/"{% else %}action="/"{% endif %} method="post" {% if application %}id="config-app-form-{{ application.identifier }}"{% endif %}>
  {% csrf_token %}

  <h3>General configurations</h3>
  <div class="mb-3 mt-3">
    <div class="d-flex flex-row gap-5">
      <label class="form-label fw-semibold">Identifier (Required)</label>
      <div class="form-label"><strong>App URL: </strong><span id="app-domain-id">{% if application %}{{ application.identifier }}{% endif %}</span>.{{ general_config.domain }}</div>
    </div>
    <div class="text-danger mb-1 d-none">Identifier already exists</div>
    <input name="identifier" type="text" class="form-control app-identifier-input" data-existing-identifiers="{{existing_identifiers}}" {% if application.identifier %}value="{{application.identifier}}" disabled {% endif %} placeholder="e.g. myapp" minlength='3' maxlength='16' pattern='^[a-z][a-z0-9-]*[a-z0-9]$' required>
    <div class="form-text">Short, unique identifier composed only of lowercase letters, numbers and hyphens and must start with a letter. This cannot be changed later and it will show up in the app's URL.</div>
  </div>

  <div class="mb-3">
    <label class="form-label">Descriptive name (Required)</label>
    <input name="descriptive_name" type="text" class="form-control descriptive-name" {% if application.descriptive_name %}value="{{application.descriptive_name}}"{% endif %} placeholder='e.g. My Application' required>
    <div class="form-text">Longer more descriptive title</div>
  </div>

  <div class="mb-3">
    <label class="form-label">Description</label>
    <textarea name="description" class="form-control" placeholder='e.g. My Application serves my research data products to a managed list of users' rows="3" {% if application.published_on_strap %}required{% endif %}>{% if application.description %}{{application.description}}{% endif %}</textarea>
    <div class="form-text">Description of application</div>
  </div>

    <!-- Display on STRAP page -->
  <div class="form-check mb-3">
    <input
      class="form-check-input"
      type="checkbox"
      name="published_on_strap"
      id="flexCheckDefault"
      {% if application.published_on_strap %}checked{% endif %}>
    <label class="form-check-label" for="flexCheckDefault">
      Okay to publish name and description on STRAP page
    </label>
  </div>

  <div class="mb-3">
    <label class="form-label">Authentication</label>
    <select class="form-control authentication" name="authentication">
      <option value='' {% if not application.authentication %}selected{% endif %}>None</option>
      <option value='uvic' {% if application.authentication == 'uvic' %}selected{% endif %}>UVic</option>
      <option value='uvic_social' {% if application.authentication == 'uvic_social' %}selected{% endif %}>UVic + Social</option>
    </select>
    <div class="form-text">How the app authenticates users</div>
  </div>

  <div class="mb-3">
    <label class="form-label">Authenticated routes</label>
    <div class="alert alert-warning d-none" role="alert" data-role="authenticated-routes-alert">
      <i class="fa-solid fa-triangle-exclamation me-2"></i>
      Route exists as an unauthenticated route. Adding this route will remove it from the unauthenticated routes
    </div>
    <div class="routes-input">
      <input
        class="form-control"
        type='text'
        {% if not application.authentication %}disabled{% endif %}
        placeholder="Type in the route, then click 'Add' to add. E.g. /dashboard, then add"
        data-type="authenticated"></input>
      <div type="button" class="btn btn-primary disabled">Add route</div>
    </div>
    <div class="route-tag-container authenticated-routes">
      {% if application.authentication %}
        {% if application.route_set.all|length > 0 %}
          {% for route in application.route_set.all %}
            {% if route.authenticated %}
              <div class="route-tag mt-1"><span class="route-tag-path">{{route.route}}</span> <span class="route-tag-close {% if not application.authentication %}disabled{% endif %}">&#10005;</span></div>
            {% endif %}
          {% endfor %}
        {% endif %}
      {% endif %}
    </div>
    <input name="authenticated_routes" class="route-hidden-input d-none authenticated-routes-input" type="text" {% if application %}value="{{application.authenticated_routes_to_str}}"{% endif %}>
    <div class="form-text">Routes subject to authentication. Click on the 'X' in each tag to remove it.</div>
  </div>

  <div class="mb-3">
    <label class="form-label">Unauthenticated routes</label>
    <div class="alert alert-warning d-none" role="alert" data-role="unauthenticated-routes-alert">
      <i class="fa-solid fa-triangle-exclamation me-2"></i>
      Route exists as an authenticated route. Adding this route will remove it from the authenticated routes
    </div>
    <div class="routes-input">
      <input
        class="form-control"
        type='text'
        {% if not application.authentication %}disabled{% endif %}
        placeholder="Type in the route, then click 'Add' to add. E.g. /, then add"
        data-type="unauthenticated"></input>
      <div type="button" class="btn btn-primary disabled">Add route</div>
    </div>
    <div class="route-tag-container unauthenticated-routes">
      {% if not application.authentication %}
        <div class="route-tag mt-1"><span class="route-tag-path">/</span> <span class="route-tag-close disabled">&#10005;</span></div>
      {% else %}
        {% if application.route_set.all|length > 0 %}
          {% for route in application.route_set.all %}
            {% if not route.authenticated %}
              <div class="route-tag mt-1"><span class="route-tag-path">{{route.route}}</span> <span class="route-tag-close">&#10005;</span></div>
            {% endif %}
          {% endfor %}
        {% endif %}
      {% endif %}
    </div>
    <input name="unauthenticated_routes" class="route-hidden-input d-none unauthenticated-routes-input" type="text"
           {% if application.authentication %}
             value="{{application.unauthenticated_routes_to_str}}"
           {% else %}
             value="/"
           {% endif %}
    >
    <div class="form-text">Routes exempt from authentication. Click on the 'X' in each tag to remove it.</div>
  </div>

  <div class="mb-4">
    <label class="form-label">Database:</label>
    <select class="form-control" name='database' {% if application.deployment %}disabled{% endif %}>
      <option value='None' {% if not application.database or application.database == 'None' %}selected{% endif %}>None</option>
      <option value='PostgreSQL' {% if application.database == 'PostgreSQL' %}selected{% endif %}>PostgreSQL</option>
      <option value='MySQL' {% if application.database == 'MySQL' %}selected{% endif %} disabled>MySQL - not yet implemented</option>
    </select>
    <div class="form-text">Select the type of database your application uses. Note that once <strong>deployed</strong>, this value <strong>cannot be changed</strong></div>
  </div>

  <div class="advanced-config" {% if application.has_advanced_config %}data-active="true"{% endif %}>
    <div id="app-advanced-config-toggle" class="advanced-config-toggle mb-2 fw-semibold fs-110percent cursor-pointer w-fit">
      <i class="fa-solid fa-caret-right me-1"></i>
      Advanced configurations
    </div>

    <div id="app-advanced-config-content" class="advanced-config-content">
      <div>
        <div class="mb-3">
          <label class="form-label">IP Access:</label>
          <div class="form-check">
            <input
              class="form-check-input"
              type="radio"
              name="ip_access"
              id="open-ip-access"
              value="open"
              {% if not application.allowed_ips %}checked{% endif %}>
            <label class="form-check-label" for="open-ip-access">
              App can be accessed from any IP - Make app world-wide accessible
            </label>
          </div>
          <div class="form-check">
            <input
              class="form-check-input"
              type="radio"
              name="ip_access"
              id="limit-ip-access"
              value="limit"
              {% if application.allowed_ips %}checked{% endif %}>
            <label class="form-check-label" for="limit-ip-access">
              Limit app access to certain IP addresses or networks
            </label>
          </div>

          <div id="ip-options" class="ps-4 mt-1 {% if not application.allowed_ips %}d-none{% endif %}">
            {% for name, ips in general_config.get_preset_ips.items %}
              <div class="form-check">
                <input
                  class="form-check-input"
                  type="checkbox"
                  name="{{ name }}"
                  {% if name in application.get_allowed_ips.keys %}checked{% endif %}>
                <label class="form-check-label">
                  {{ name }} - {{ ips|join:", " }}
                </label>
              </div>
            {% endfor %}
            <div class="form-check">
              <input
                class="form-check-input"
                type="checkbox"
                name="other_ips"
                id="other-ips"
                {% if application.get_allowed_ips.others %}checked{% endif %}>
              <label class="form-check-label" for="other-ips">
                Others
              </label>
            </div>
            <div id="allowed-ips-div" class="{% if not application.get_allowed_ips.others %}d-none{% endif %}">
              <div id="allowed-ips-container">
                <label class="fw-light fst-italic fs-80percent">Specify either an IP address or network</label>
                {% if application.get_allowed_ips.others %}
                  {% for ip in application.get_allowed_ips.others %}
                    <div class="allowed-ip-item my-1">
                      <div class="d-flex flex-row gap-2 align-items-center">
                        <input
                          class="form-control"
                          type="text"
                          name="allowed_ips"
                          value="{{ip}}"
                          pattern="^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}(/[0-9]{1,2})?$"
                          placeholder="0.0.0.0/0"
                          aria-label="Other IPs list">
                        <i class="allowed-ip-remove-btn fa-solid fa-trash icon-btn-dark"></i>
                      </div>
                    </div>
                  {% endfor %}
                {% else %}
                  <div class="allowed-ip-item my-1">
                    <div class="d-flex flex-row gap-2 align-items-center">
                      <input
                        class="form-control"
                        type="text"
                        name="allowed_ips"
                        value=""
                        pattern="^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}(/[0-9]{1,2})?$"
                        placeholder="0.0.0.0/0"
                        aria-label="Other IPs list">
                      <i class="allowed-ip-remove-btn fa-solid fa-trash icon-btn-dark"></i>
                    </div>
                  </div>
                {% endif %}
              </div>
              <div id="add-ip-input-btn" class="fs-90percent text-btn-dark mt-2">+ Add IP address or network</div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <div class="mt-4">
    <button type="submit" class="btn btn-primary">{% if application %}Submit{% else %}Create app{% endif %}</button>
    <div class="btn btn-danger {% if application %}{% if app_card == 1 %}app-card-edit-cancel-btn{% else %}app-summary-edit-cancel-btn{% endif %}{% else %}app-create-cancel-btn{% endif %}">Cancel</div>
  </div>
</form>
